
include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include gdi32.inc
include shlwapi.inc
include msvcrt.inc
include comdlg32.inc

includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib shell32.lib
includelib gdi32.lib
includelib shlwapi.lib
includelib msvcrt.lib
includelib comdlg32.lib

bsbChart3				PROTO
bsbHeader3				PROTO
bsbIndex3				PROTO
ChartProc				PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ChartThread				PROTO	:dword
CreateEvents			PROTO
CreateThreads			PROTO
GetBSBFullRows			PROTO
GetRowPixels			PROTO	:dword,:dword,:dword
IndexThread				PROTO	:dword
MainDlgProc				PROTO	:HWND,:UINT,:WPARAM,:LPARAM
prepareHeaders3			PROTO
PrepareThread			PROTO	:dword
Read					PROTO	:dword
Write					PROTO	:dword,:dword,:dword,:dword
Write1Thread			PROTO	:dword
Write2Thread			PROTO	:dword

include Macro.inc
include Struct.inc

.const
EOF								equ -1
TEMPSIZE						equ 8000h						

;MainDlg.dlg
IDD_MAINDLG						equ 1000
IDC_CHART						equ 1001

;NavApp.mnu
IDR_MENU						equ 10000
IDM_ITEM						equ 10001
IDM_PART						equ 10002
IDM_CLOSE						equ 10003
IDM_COMP						equ 10004
IDM_PART2						equ 10005

.data
mul_mask						db 8 DUP(0,63,31,15,7,3,1,0)

.data?
;Process 
hInstance						dd ?
hMain							dd ?
hCHART							dd ?
x								dd ?
y								dd ?
hDC								dd ?
hHeap							dd ?
OldChartProc					dd ?
szFileName						db 256 dup (?)
tickcount						dd ?

;BSB header
bsbH							dd ?
bsbW							dd ?
ColorDepth						dd ?

;Bitmap header
hBitmap							dd ?
imageH							dd ?
imageW							dd ?
padding							dd ?

;Memory
pBMI							dd ?
pBSB							dd ?
bsbsize							dd ?
pIndex							dd ?
pPixelData						dd ?
memorysize						dd ?

;variables read/write events
readstart						dd ? ;position to start a reading of pixel data in memory
rowsread						dd ? ;number of rows to read from disk
prevIndex						dd ? ;previous index in jumptable on disk
rowIndex						dd ? ;index in jumptable on disk
memout							dd ? ;size of memory corresponding to read rows
pFile							dd ?

;Events and Threads
hPrepareEvent					dd ?
hIndexEvent						dd ?
hChartEvents					dd 3 dup (?)
hChart1Event					dd ?
hChart2Event					dd ?
hChart3Event					dd ?
hRead1Event						dd ?
hRead2Event						dd ?
hFinish1Event					dd ?
hFinish2Event					dd ?
hWriteEvents					dd 2 dup(?)
hWrite1Event					dd ?
hWrite2Event					dd ?

